#define RDSIZE       1536
#define NAMESIZE     80

int new_world( WORLD *world );
int destroy_world( WORLD *world );
int add_zone( WORLD *world );
int del_zone( WORLD *world, int index );
int add_room( ZONE *zone, int x, int y, int z );
int del_room( ZONE *zone, int index );
int move_room_to_zone( ZONE *from, int index, ZONE *to );
int add_room_exd( ROOM *room );
int del_room_exd( ROOM *room, int index );
int add_room_content( ROOM *room );
int del_room_content( ROOM *room, int index );
int add_object_exd( OBJECT *object );
int del_object_exd( OBJECT *object, int index );
int add_object_affect( OBJECT *object );
int del_object_affect( OBJECT *object, int index );
int add_door( ROOM *room1, int dir1, ROOM *room2, int dir2 );
int add_hanging_door( ROOM *room, int dir );
int del_door( ROOM *room, int index );
int add_tag( ZONE *zone, int x, int y, int z );
int del_tag( ZONE *zone, int index );
int add_object( ZONE *zone );
int del_object( ZONE *zone, int index );
int add_mobile( ZONE *zone );
int del_mobile( ZONE *zone, int index );
int add_shop( ZONE *zone );
int del_shop( ZONE *zone, int index );
int add_shop_item( SHOP *shop );
int del_shop_item( SHOP *shop, int index );
int add_shop_room( SHOP *shop );
int del_shop_room( SHOP *shop, int index );
int add_shop_bspec( SHOP *shop );
int del_shop_bspec( SHOP *shop, int index );

void rehash_world( WORLD *world );
void rehash_zone( ZONE *zone );
void rehash_room( ROOM *room );

int calc_world_size( WORLD *world );

void sort_zones( WORLD *world );

/* Clipboard stuff
 ***/
#define CBT_ROOM        1

int destroy_board_data( BOARD *board );
int copy_room_to_board( ROOM *room, BOARD *board );
int paste_board_to_zone( BOARD *board, ZONE *zone );

/* MSel (ringbuffer) stuff
 ***/
MSEL_ITEM *add_msel_item( MSEL *msel, int hi_ind, int lo_ind );
int del_msel_item( MSEL *msel, int hi_ind, int lo_ind );
int del_msel_list( MSEL *msel );

